local version = 2.0
--[[

    Vital Watch 
        Author:         Nikolas Davis (Based On Original Code by Sean Kennedy)
        Version:        2.0
        ToDo:           Add gui (when time permits
                        Add ability to have different warn levels for 
                        each party member.
        Last Modified:  3/24/05
        Thanks to Patho on Test 8 for his help in testing the 
        party enhancement.
]]

-- Configuration variables
    VitalWatchFirstUse = 0;        	-- Saved
    VitalWatchEnabled = 0;         	-- Saved - 1 = on, 0 = off
    VitalWatchChatPleaEnabled = 0; 	-- Saved - 1 = on, 0 = off
	VitalWatchManaWatchEnabled = 1;	-- Saved - 1 = on, 0 = off
	VitalWatchUseEmote = 1;			-- Saved - 1 = on, 0 = off
    VitalWatchWarnLevel = {};      	-- Saved - decimal representation (.00 to 1.0)
    VitalWatchCritLevel = {};      	-- Saved - level for second, desperate warning
    VitalWatchManaWarn = {};  		-- Saved - decimal representation (.00 to 1.0)
    VitalWatchManaCrit = {};  		-- Saved - level for second, desperate warning
    VitalWatchWarnPlea = {};       	-- Saved - message to send to party on warnlevel
    VitalWatchCritPlea = {};       	-- Saved - message to send to party on desperate warning
    VitalWatchManaWarnPlea = {};   	-- Saved - message to send to party on mana warnlevel
    VitalWatchManaCritPlea = {};   	-- Saved - message to send to party on desperate mana warning
    VitalWatchWarnSound = {};      	-- Saved
    VitalWatchCritSound = {};      	-- Saved
-- Local variables
    local mLastHPPercent = {};
	local mLastMAPercent = {};
-- OnFoo functions
function VitalWatchOnLoad()
-- respond to health and mana changes and saved variable load
	this:RegisterEvent("UNIT_HEALTH");
	this:RegisterEvent("UNIT_MANA");
	this:RegisterEvent("VARIABLES_LOADED");
-- initialize previous hp and mp percentage
    mLastHPPercent["player"] = UnitHealth("player") / UnitHealthMax("player");
    mLastMAPercent["player"] = UnitMana("player") / UnitManaMax("player");
    mLastHPPercent["party1"] = 0;
    mLastHPPercent["party2"] = 0;
    mLastHPPercent["party3"] = 0;
    mLastHPPercent["party4"] = 0;
end

function VitalWatchOnEvent()
local HPPercent;
local MAPercent;
local text;
local warnlevel, critlevel, manawarn, manacrit, warnsound, critsound, name;

    if (event == "UNIT_HEALTH") then
        if (arg1 == "player") then
        -- Player health changed.  Sound alarm as it drops under warnlevel
            name = string.lower(UnitName(arg1));
            warnlevel = VitalWatchWarnLevel[name] or VitalWatchWarnLevel["hw_default"];
            critlevel = VitalWatchCritLevel[name] or VitalWatchCritLevel["hw_default"];
            warnsound = VitalWatchWarnSound[name] or VitalWatchWarnSound["hw_default"];
            critsound = VitalWatchCritSound[name] or VitalWatchCritSound["hw_default"];
            HPPercent = UnitHealth("player") / UnitHealthMax("player");
            if (HPPercent < warnlevel) and (mLastHPPercent[arg1] >= warnlevel) then
                if (VitalWatchEnabled == 1) then
					if (VitalWatchUseEmote == 1) then
						DoEmote("healme");
						VitalWatchFloatMsg("Your health is LOW", "yellow");
					else
						PlaySoundFile(warnsound);
						VitalWatchFloatMsg("Your health is LOW", "yellow");
					end
                    if (VitalWatchChatPleaEnabled == 1)  and (GetPartyMember(1) ~= nil) then
                        SendChatMessage(VitalWatchWarnPlea, "PARTY"); 
                    end
                end
            end
            if (HPPercent < critlevel) and (mLastHPPercent[arg1] >= critlevel) then
                if (VitalWatchEnabled == 1) then
					if (VitalWatchUseEmote == 1) then
						DoEmote("helpme");
						VitalWatchFloatMsg("Your health is CRITICAL", "red");
					else
						PlaySoundFile(critsound);
						VitalWatchFloatMsg("Your health is CRITICAL", "red");
					end
                    if (VitalWatchChatPleaEnabled == 1) and (GetPartyMember(1) ~= nil) then
                        SendChatMessage(VitalWatchCritPlea, "PARTY"); 
                    end
                end
            end
            mLastHPPercent[arg1] = HPPercent;      
        elseif (arg1 == "party1") or (arg1 == "party2") or (arg1 == "party3") or (arg1 == "party4") then
        -- Party Member being hit - all characters except player get unit health in %
            name = string.lower(UnitName(arg1));
            warnlevel = VitalWatchWarnLevel[name] or VitalWatchWarnLevel["hw_default"];
            critlevel = VitalWatchCritLevel[name] or VitalWatchCritLevel["hw_default"];
            warnsound = VitalWatchWarnSound[name] or VitalWatchWarnSound["hw_default"];
            critsound = VitalWatchCritSound[name] or VitalWatchCritSound["hw_default"];
            HPPercent = UnitHealth(arg1) / UnitHealthMax(arg1);
            if (HPPercent < warnlevel) and (mLastHPPercent[arg1] >= warnlevel) then
                if (VitalWatchEnabled == 1) then
                    PlaySoundFile(warnsound);
                    VitalWatchFloatMsg(name .. "'s health is LOW", "yellow");
                end
            end
            if (HPPercent < critlevel) and (mLastHPPercent[arg1] >= critlevel) then
                if (VitalWatchEnabled == 1) then
                    PlaySoundFile(critsound);
                    VitalWatchFloatMsg(name .. "'s health is CRITICAL", "red");
                end
            end
            mLastHPPercent[arg1] = HPPercent;      
        end    
    elseif (event == "UNIT_MANA") then
        if (arg1 == "player") then
        -- Player mana changed.  Sound alarm as it drops under warnlevel
            name = string.lower(UnitName(arg1));
            manawarn = VitalWatchManaWarn[name] or VitalWatchManaWarn["hw_default"];
            manacrit = VitalWatchManaCrit[name] or VitalWatchManaCrit["hw_default"];
            warnsound = VitalWatchWarnSound[name] or VitalWatchWarnSound["hw_default"];
            critsound = VitalWatchCritSound[name] or VitalWatchCritSound["hw_default"];
            MAPercent = UnitMana("player") / UnitManaMax("player");
            if (MAPercent < manawarn) and (mLastMAPercent[arg1] >= manawarn) then
                if (VitalWatchEnabled == 1) then
					if (VitalWatchManaWatchEnabled == 1) and (GetPartyMember(1) ~= nil) then
						SendChatMessage(VitalWatchManaWarnPlea, "PARTY");
						VitalWatchFloatMsg("Your mana is LOW", "cyan");
					else
						VitalWatchFloatMsg("Your mana is LOW", "cyan");
					end
                end
            end
            if (MAPercent < manacrit) and (mLastMAPercent[arg1] >= manacrit) then
                if (VitalWatchEnabled == 1) then
					if (VitalWatchManaWatchEnabled == 1) and (GetPartyMember(1) ~= nil) then
						SendChatMessage(VitalWatchManaCritPlea, "PARTY");
						VitalWatchFloatMsg("Your mana is CRITICAL", "blue");
					else
						VitalWatchFloatMsg("Your mana is CRITICAL", "blue");
					end                 
                end
            end
            mLastMAPercent[arg1] = MAPercent;         
        end
    elseif (event == "VARIABLES_LOADED") then
    -- Saved variables loaded - check for first use and load defaults if necessary
        if (VitalWatchFirstUse == 0) then
            VitalWatchLoadDefaults();
        end
    -- Register for save
   -- Register command handler and new commands
		SlashCmdList["VitalWatchCOMMAND"] = VitalWatchSlashHandler;
		SLASH_VitalWatchCOMMAND1 = "/vitalwatch";
		SLASH_VitalWatchCOMMAND2 = "/vw";
    -- Report load
        VitalWatchChatMsg(format("Vital Watch Loaded v %.2f, type /vitalwatch for usage",version));
    end
end

-- Helper Functions
function VitalWatchSetWarnLevel(name, level)
local text

    if (level >= 0) and (level <= 1.0 ) then
        VitalWatchWarnLevel[name] = level;
    end

    text = format("Health Warning for " .. name .. " at %d percent", (VitalWatchWarnLevel[name] * 100));

    VitalWatchFloatMsg(text, "white");
end

function VitalWatchSetCritLevel(name, level)
local text

    if (level >= 0) and (level <= 1.0 ) then
        VitalWatchCritLevel[name] = level;
    end

    text = format("Critical Health Warning for " .. name .. " at %d percent", (VitalWatchCritLevel[name] * 100));

    VitalWatchFloatMsg(text, "white");
end

function VitalWatchSetManaWarn(name, level)
local text

    if (level >= 0) and (level <= 1.0 ) then
        VitalWatchManaWarn[name] = level;
    end

    text = format("Mana Warning for " .. name .. " at %d percent", (VitalWatchManaWarn[name] * 100));

    VitalWatchFloatMsg(text, "white");
end

function VitalWatchSetManaCrit(name, level)
local text

    if (level >= 0) and (level <= 1.0 ) then
        VitalWatchManaCrit[name] = level;
    end

    text = format("Critical Mana Warning for " .. name .. " at %d percent", (VitalWatchManaCrit[name] * 100));

    VitalWatchFloatMsg(text, "white");
end

function VitalWatchSetWarnPlea(msg)
local text

    VitalWatchWarnPlea = msg;

    text = "Party Health warning message is: " .. VitalWatchWarnPlea;

    VitalWatchFloatMsg(text, "white");
end

function VitalWatchSetCritPlea(msg)
local text

    VitalWatchCritPlea = msg;

    text = "Party Critical Health warning message is: " .. VitalWatchCritPlea;

    VitalWatchFloatMsg(text, "white");
end

function VitalWatchSetManaWarnPlea(msg)
local text

    VitalWatchManaWarnPlea = msg;

    text = "Party Mana warning message is: " .. VitalWatchManaWarnPlea;

    VitalWatchFloatMsg(text, "white");
end

function VitalWatchSetManaCritPlea(msg)
local text

    VitalWatchManaCritPlea = msg;

    text = "Party Critical Mana warning message is: " .. VitalWatchManaCritPlea;

    VitalWatchFloatMsg(text, "white");
end

function VitalWatchSetEnabled(toggle)
    toggle = string.lower(toggle);
    if (toggle == "off") then
        VitalWatchEnabled = 0;
        VitalWatchFloatMsg("Vital Watch Off");
    else
        VitalWatchEnabled = 1;
        VitalWatchFloatMsg("Vital Watch On");
    end        
end

function VitalWatchSetManaWatchEnabled(toggle)
    toggle = string.lower(toggle);
    if (toggle == "off") then
        VitalWatchManaWatchEnabled = 0;
        VitalWatchFloatMsg("Mana Watch Off");
    else
        VitalWatchManaWatchEnabled = 1;
        VitalWatchFloatMsg("Mana Watch On");
    end        
end

function VitalWatchSetChatPleaEnabled(toggle)
    toggle = string.lower(toggle);
    if (toggle == "off") then
        VitalWatchChatPleaEnabled = 0;
        VitalWatchFloatMsg("Party Warning Off");
    else
        VitalWatchChatPleaEnabled = 1;
        VitalWatchFloatMsg("Party Warning On");
    end        
end

function VitalWatchSetUseEmote(toggle)
    toggle = string.lower(toggle);
    if (toggle == "off") then
        VitalWatchUseEmote = 0;
        VitalWatchFloatMsg("No longer using emotes for warning");
    else
        VitalWatchUseEmote = 1;
        VitalWatchFloatMsg("Now using emotes for warning");
    end        
end

function VitalWatchSetWarnSound(name, soundfile)
    VitalWatchWarnSound[name] = soundfile .. ".wav";
    VitalWatchFloatMsg("Warning sound for " .. name .. " is " .. VitalWatchWarnSound[name]);
end

function VitalWatchSetCritSound(name, soundfile)
    VitalWatchCritSound[name] = soundfile .. ".wav";
    VitalWatchFloatMsg("Critical sound for " .. name .. " is " .. VitalWatchCritSound[name]);
end

function VitalWatchSlashHandler(msg)
local text = msg;
	msg = string.lower(msg);

-- check for 3 arguments first
	local firsti, lasti, command, name, value = string.find (msg, "(%w+) (%w+) ([_%w]+)");
-- if there weren't 3, then command will be nil - check for two args    
    if (command == nil) then
        firsti, lasti, command, value = string.find(msg, "(%w+) ([_%w]+)");
        name = "hw_default";
    end    
-- if there weren't 2 - check for one
    if (command == nil) then
        firsti, lasti, command = string.find(msg, "(%w+)");
    end

-- respond to commands
    if (command == nil) then
        VitalWatchDisplayUseage();
    elseif (string.lower(command) == "enable") then
        VitalWatchSetEnabled("on");
    elseif (string.lower(command) == "disable") then
        VitalWatchSetEnabled("off");
    elseif (string.lower(command) == "manawatch") then
        if (string.lower(value) == "enable") then
            VitalWatchSetManaWatchEnabled("on");
        elseif (string.lower(value) == "disable") then
            VitalWatchSetManaWatchEnabled("off")
        end
    elseif (string.lower(command) == "reset") then
        VitalWatchLoadDefaults();
        VitalWatchDisplayStatus();
    elseif (string.lower(command) == "status") then
        VitalWatchDisplayStatus();
    elseif (string.lower(command) == "chatplea") then
        if (string.lower(value) == "enable") then
            VitalWatchSetChatPleaEnabled("on");
        elseif (string.lower(value) == "disable") then
            VitalWatchSetChatPleaEnabled("off")
        end
    elseif (string.lower(command) == "useemote") then
        if (string.lower(value) == "enable") then
            VitalWatchSetUseEmote("on");
        elseif (string.lower(value) == "disable") then
            VitalWatchSetUseEmote("off")
        end
    elseif (string.lower(command) == "warnmsg") then
        VitalWatchSetWarnPlea(string.sub(text, lasti+3, -2));
    elseif (string.lower(command) == "critmsg") then
        VitalWatchSetCritPlea(string.sub(text, lasti+3, -2));
    elseif (string.lower(command) == "manawarnmsg") then
        VitalWatchSetManaWarnPlea(string.sub(text, lasti+3, -2));
    elseif (string.lower(command) == "manacritmsg") then
        VitalWatchSetManaCritPlea(string.sub(text, lasti+3, -2));
    elseif (string.lower(command) == "warnlevel") then
        if (value == nil) then 
            VitalWatchDisplayUseage();
        else
            value = value / 100;
            VitalWatchSetWarnLevel(string.lower(name), value);
        end
    elseif (string.lower(command) == "critlevel") then
        if (value == nil) then 
            VitalWatchDisplayUseage();
        else
            value = value / 100;
            VitalWatchSetCritLevel(string.lower(name), value);
        end
    elseif (string.lower(command) == "manawarn") then
        if (value == nil) then 
            VitalWatchDisplayUseage();
        else
            value = value / 100;
            VitalWatchSetManaWarn(string.lower(name), value);
        end
    elseif (string.lower(command) == "manacrit") then
        if (value == nil) then 
            VitalWatchDisplayUseage();
        else
            value = value / 100;
            VitalWatchSetManaCrit(string.lower(name), value);
        end
    elseif (string.lower(command) == "warnsound") then
        if (value == nil) then 
            VitalWatchDisplayUseage();
        else
            VitalWatchSetWarnSound(string.lower(name), value);
        end
    elseif (string.lower(command) == "critsound") then
        if (value == nil) then 
            VitalWatchDisplayUseage();
        else
            VitalWatchSetCritSound(string.lower(name), value);
        end
    else
        VitalWatchDisplayUseage();
    end
end

function VitalWatchDisplayStatus()
local text, name, warnlevel, critlevel, manawarn, manacrit, warnsound, critsound;
    text = "Vital Watch ";
    if (VitalWatchEnabled == 1) then
        text = text .. "On"
        if (VitalWatchChatPleaEnabled == 1) then
            text = text .. "\nParty warning enabled";
            text = text .. "\nHealth warning message is: \n"; 
            text = text ..VitalWatchWarnPlea;
            text = text .. "\nCritical health message is: \n";
            text = text ..VitalWatchCritPlea;
            text = text .. "\nMana Warning message is: \n";
            text = text ..VitalWatchManaWarnPlea;
            text = text .. "\nCritical Mana message is: \n";
			text = text ..VitalWatchManaCritPlea;
        else
            text = text .. "\nParty message disabled";
        end
    else
        text = text .. "Off";
    end
    text = "Mana Watch ";
    if (VitalWatchManaWatchEnabled == 1) then
		text = text .. "On";
	else
		text = text .. "Off";
	end
    VitalWatchChatMsg(text);
    for name in VitalWatchWarnLevel do
        warnlevel = VitalWatchWarnLevel[name] or VitalWatchWarnLevel["hw_default"];
        critlevel = VitalWatchCritLevel[name] or VitalWatchCritLevel["hw_default"];
        manawarn = VitalWatchManaWarn[name] or VitalWatchManaWarn["hw_default"];
        manacrit = VitalWatchManaCrit[name] or VitalWatchManaCrit["hw_default"];
        warnsound = VitalWatchWarnSound[name] or VitalWatchWarnSound["hw_default"];
        critsound = VitalWatchCritSound[name] or VitalWatchCritSound["hw_default"];
        VitalWatchChatMsg("-- " .. name .. " health warning at " .. (warnlevel * 100) .. "%, health critical at " .. (critlevel * 100) .. "%");
        VitalWatchChatMsg("-- " .. name .. " mana warning at " .. (manawarn * 100) .. "%, mana critical at " .. (manacrit * 100) .. "%");
        VitalWatchChatMsg("-- " .. name .. " warn sound is '" .. warnsound .. "'");
        VitalWatchChatMsg("-- " .. name .. " crit sound is '" .. critsound .. "'");
    end
end

function VitalWatchDisplayUseage()
local text;

    text = "Usage: \n";
    text = text .. "/VitalWatch <Enable | Disable | Status | Reset>\n";
    text = text .. "/VitalWatch ManaWatch <Enabled | Disable>\n";
    text = text .. "/VitalWatch ChatPlea <Enable | Disable>\n";
    text = text .. "/VitalWatch <WarnLevel | CritLevel> <name> <value (0-100)>\n";
    text = text .. "/VitalWatch <ManaWarn | ManaCrit> <name> <value (0-100)>\n";
    text = text .. "/VitalWatch <WarnMsg | CritMsg> <message>\n";
    text = text .. "/VitalWatch <ManaWarnMsg | ManaCritMsg> <message>\n";
    text = text .. "/VitalWatch <WarnSound | CritSound> <name> <soundfile>\n";
    VitalWatchChatMsg(text, "white");
	text = "/VitalWatch UseEmote <Enable | Disable>\n";
    VitalWatchChatMsg(text, "white");
end

function VitalWatchChatMsg(msg)
	if( DEFAULT_CHAT_FRAME ) then
		DEFAULT_CHAT_FRAME:AddMessage(msg);
	end
end

function VitalWatchFloatMsg(msg, color)
-- Display overhead message.  7 basic colors available
-- Use at most 3 lines here - the rest get lost
local r, g, b

    if (color == nil) then 
        color = "white";
    end

    if (string.lower(color) == "red") then
        r, g, b = 1, 0, 0;
    elseif (string.lower(color) == "green") then
        r, g, b = 0, 1, 0;
    elseif (string.lower(color) == "blue") then
        r, g, b = 0, 0, 1;
    elseif (string.lower(color) == "magenta") then
        r, g, b = 1, 0, 1;
    elseif (string.lower(color) == "yellow") then
        r, g, b = 1, 1, 0;
    elseif (string.lower(color) == "cyan") then
        r, g, b = 0, 1, 1;
    else 
        r, g, b = 1, 1, 1;
    end

	VitalwatchMessageFrame:AddMessage(msg, r, g, b, 1, 3);
    
end

function VitalWatchLoadDefaults()
local text;
    VitalWatchFirstUse = 1;        
    VitalWatchEnabled = 1;         
    ViatlWatchManaWatchEnabled = 1;
    VitalWatchChatPleaEnabled = 0; 
	VitalWatchUseEmote = 1;
    VitalWatchWarnLevel = {};
    VitalWatchCritLevel = {};
    VitalWatchManaWarn = {};
    VitalWatchManaCrit = {};
    VitalWatchWarnSound = {};
    VitalWatchCritSound = {};
    VitalWatchWarnLevel["hw_default"] = .4;      
    VitalWatchCritLevel["hw_default"] = .2;   
    VitalWatchManaWarn["hw_default"] = .4;      
    VitalWatchManaCrit["hw_default"] = .2; 
    VitalWatchWarnPlea = "VitalWatch: My health is low!"; 
    VitalWatchCritPlea = "VitalWatch: My health is critical!";
    VitalWatchManaWarnPlea = "VitalWatch: My mana is low!";
    VitalWatchManaCritPlea = "VitalWatch: My mana is dangerously low!";
    VitalWatchWarnSound["hw_default"] = "hitom.wav";
    VitalWatchCritSound["hw_default"] = "lowtom.wav";
    text = "Healthwatch loading defaults\n";
    text = text .. "type /healthwatch for commands\n"
	VitalWatchChatMsg(text);
end
